(****** TIPE d'Informatique (2me anne) ******)
(* modifi le 22/01/98 *)



(** Transformation Dessin ---> Arbre **)
#open "graphics";;
directory "";; (* A modifier selon le systme *)
include "utilit.ml";;

(* Si vous avez compil utilit.ml, supprimer la ligne prcdente
et utilisez plutt les commandes suivantes
load_object "utilit";;
#open "utilit";;
*)

(* Les distance et norme infinies : utile pour les carrs autour des valeurs (Je n'aime pas les cercles) *)
let norme (x,y) = max (abs x) (abs y);;
let dist (x1,y1) (x2,y2) = norme (x1-x2,y1-y2);;

(* Calcul du point le plus proche d'un autre point *) 
let pt_proche pt_fix =
	let rec min_dist voisin mini = function
		|[]	-> voisin
		|t::q -> let N=dist t.coord pt_fix in 
				if mini<N
				then min_dist voisin mini q
				else min_dist t N q
in	min_dist {coord=(-1,-1); val=ref ""} (size_x()+1)
;;

(* Remplace point par sa nouvelle valeur dans une liste *)
let rec remplace point = function
	|[]	-> raise (Erreur "Erreur dans remplace : Point non prsent")
	|t::q -> if  t.coord=point.coord then point::q else t::(remplace point q)
;;

(* Supprime point de la liste des points et des liaisons *)
let rec supprime_ds_pt point = function
	|[]	-> raise (Erreur "Erreur dans supprime_ds_pt : Point non prsent")
	|t::q -> if  t.coord=point.coord then q else t::(supprime_ds_pt point q)
;;
let rec supprime_ds_liaison point = function
	|[]	-> []
	|t::q -> 	if (fst t).coord=point.coord or (snd t).coord=point.coord 
			then supprime_ds_liaison point q
			else t::(supprime_ds_liaison point q)
;;

(* Les fonctions d'affichage *)
let taille_pt point = let (a,b)=text_size !(point.val) in (4+a/2,1+b/2);;

let dessine_pt couleur point = let (a,b)=taille_pt point and (x,y)=point.coord in
	set_color background;
	fill_rect (x-a) (y-b) (2*a) (2*b);
	set_color couleur;
	moveto (x-a+5) (y-b+1); draw_string !(point.val);
	draw_rect (x-a) (y-b) (2*a) (2*b)
;;

let dessine_liaison color (pt1, pt2) = let (x1,y1)=pt1.coord and (x2,y2)=pt2.coord in
	set_color color;
	moveto x1 y1; lineto x2 y2
;;

(* Le problme des intersections des liaisons avec les cadres des points a t rgl en traant les liaisons avant les cadres et en remplissant les cadres de la couleur du fond *) 
let dessine_tt liste_pt liste_liaison point_curr trace =
	if trace then
		begin
		do_list (dessine_liaison black) liste_liaison;
		do_list (dessine_pt black) liste_pt;
		dessine_pt red point_curr;
		end
	else
		begin
		do_list (dessine_liaison background) liste_liaison;
		do_list (dessine_pt background) liste_pt;
		end
;;

(* let pt={coord=(100,100); val=ref "toto"};;
let liaison=[({coord=(200,200); val=ref "tata"},pt);({coord=(50,50); val=ref "titi"},pt)] and
point=[pt;{coord=(200,200); val=ref "tata"};{coord=(50,50); val=ref "titi"}];;
open_graph "";;
dessine_tt point liaison pt true;; *)

(* L'interface de dessin :
	La fonction dessin va retourner, pour le traitement, la liste des points et des liaisons cres et la racine du futur arbre. Elle utilise en grande partie la souris pour la cration de nouveaux points et la slection du point courant (dessin en rouge). Pour dfinir une liaison, il faut appuyer sur `L` ou `l` puis cliquer sur le premier point et tracer une ligne en cliquant sur le deuxime. Si vous cliquez  un endroit o il n'y a pas de point, un nouveau point est cr. On peut aussi supprimer le point courant en appuyant sur `S` ou `s` ou changer la valeur du point courant en appuyant sur `Entre`. Toutes les liaisons partant de ce point seront alors supprimes. Pour sortir, appuyer sur `Echap`. Attention , le dernier point slectionn est considr comme la racine du graphe dessin. *)
let dessin () =
	let statut=ref {mouse_x=0; mouse_y=0; button=false; keypressed=false; key=`\000`}
	and point_curr=ref {coord=(-10,-10); val=ref ""}
	and liste_point= ref [] and liste_liaison=ref []

(* Dit si (x2,y2) est dans le cadre de pt1 *) 
in	let est_ds_pt pt1 (x2,y2) =
		let (a,b)=taille_pt pt1 and (x1,y1)=pt1.coord in (abs(x1-x2)<=a & abs(y1-y2)<=b)

(* Traitement des nouveaux points (ou dj prsents !!) *) 
in	let traite_newpt point = let pt=pt_proche point !liste_point in
		if (est_ds_pt pt point)
		then point_curr:=pt
		else let new_val=saisie_ext() in 
				(point_curr:={coord=point; val=ref new_val};
				 liste_point:=!point_curr::!liste_point)

in	let trace_liaison etat origine = let pt=trace_ligne etat origine.coord in 
		traite_newpt pt; 
		liste_liaison:=(origine,!point_curr)::!liste_liaison

in	while (int_of_char !statut.key)<>27 do
		dessine_tt !liste_point !liste_liaison !point_curr true;
		statut:=wait_next_event [Button_down; Key_pressed];

		if !statut.button then traite_newpt (!statut.mouse_x,!statut.mouse_y)
		else 	if !statut.keypressed then
				begin
				match (int_of_char !statut.key) with
(* Entre *)			|13 -> let new_val=saisie_ext() in 
							(!point_curr.val:=new_val; 
							 liste_point:=remplace !point_curr !liste_point)

(* L *)				|76|108 ->  begin
							statut:=wait_next_event [Button_down];
							traite_newpt (!statut.mouse_x,!statut.mouse_y);
							dessine_pt black !point_curr;
							trace_liaison statut !point_curr
							end

(* S *)				|83|115 ->  begin
							dessine_tt !liste_point !liste_liaison !point_curr false;
							liste_point:=supprime_ds_pt !point_curr !liste_point;
							liste_liaison:=supprime_ds_liaison !point_curr !liste_liaison;
							point_curr:={coord=(-10,-10); val=ref ""}
							end

					|_ -> ()
				end
			else ()
	done;
	(vect_of_list !liste_point,vect_of_list !liste_liaison,!point_curr)
;;

(* open_graph ""; dessin();; *)

(* Le traitement du graphe *)
(* Le type d'arbre *)4
type GNOCA = 	(* Graphe Non Orient Connexe Acyclique : en bref, arbre ... *)
	|Nil
	|Feuille of string
	|Noeud of string*(GNOCA vect)
;;

(* Transformation du graphe en arbre *) 
let traitement (tab_pt,tab_liaison,pt_racine) =
	let long_pt=(vect_length tab_pt)-1 and long_liaison=vect_length tab_liaison
(* Matrice des liaisons entre les points *) 
in	let voisinage=make_matrix (long_pt+1) (long_pt+1) 0

(* Retourne l'indice de l'lment x dans le tableau tab *) 
in	let indice x tab = let c=ref 0 and fini=ref false in
		while (not !fini) do (fini:=(x=tab.(!c));incr c) done;
		!c -1

(* Met  jour voisinage en cochant les points dj traits *) 
	and met__jour k =
		for c=0 to long_pt do
			if voisinage.(c).(k)=1 then voisinage.(c).(k) <- 2
		done

(* Retourne les voisins non dj traits du point tab.(k) *) 
	and cree_voisins k = let voisins=ref [] in
		for m=0 to long_pt do
			if voisinage.(k).(m)=1 then voisins:=m::(!voisins)
		done;
		!voisins

(* Dtermination du caractre connexe d'un arbre *)
in	let est_connexe dpart = 
		let temp=make_vect (long_pt+1) false
		and traite tab = let result=ref true and c=ref 0 and long=(vect_length tab -1) in
			while (!result & !c<=long) do
				result:=tab.(!c);
				incr c
			done;
			!result
	in	let rec test a_traiter deja_vu = match a_traiter with
			|[] -> traite temp
			|t::q -> let voisins=cree_voisins t in
				begin
				do_list (fun k -> (temp.(k)<-true)) voisins;
				test (union q (subtract voisins deja_vu)) (union (t::voisins) deja_vu);
				end
	in	(temp.(dpart)<-true; test [dpart] [])

(* Cre l'arbre (ou GNOCA...) d'aprs le graphe *)
in	let rec cree_arbre k = let courant=tab_pt.(k) and voisins=vect_of_list (cree_voisins k) in
		begin
		do_vect met__jour voisins;
		match (vect_length voisins) with
			|0 -> Feuille !(courant.val)
			|_ -> Noeud(!(courant.val), map_vect cree_arbre voisins);
		end

in	if long_pt= -1 then Nil
	else let ind_rac=indice pt_racine tab_pt in
	 	begin
		for c=0 to (long_liaison-1) do
			let (x,y)=tab_liaison.(c) in
				begin
				voisinage.(indice x tab_pt).(indice y tab_pt) <- 1;
				voisinage.(indice y tab_pt).(indice x tab_pt) <- 1;
				end
		done;
		if (est_connexe ind_rac & long_liaison=long_pt)
		then (met__jour ind_rac; cree_arbre ind_rac)
		else raise (Erreur "Graphe cyclique ou non connexe")
		end
;;

(* La fonction finale *)
let boulot () = 
	open_graph "";
	let graphe=dessin() in traitement graphe
;;

(*boulot();;*)


