 (** Transformation Arbre <---> Dessin **)


type ('a,'b) arbre=
	|Nil
	|Feuille of 'a
	|Noeud of 'b*(('a,'b) arbre list)
;;

#load "graphics.cmo";;
open Graphics;;

let trace arbre tracea traceb pasy =
	let dim_y= snd (text_size "a") in
	let rec traceliste x y w = function
		|[] -> ()
		|t::q -> (rtrace t x y w;
			   	 traceliste (x+w) y w q)
	and rtrace arbre x y w = match arbre with
		|Nil -> ()
		|Feuille(valeur) -> tracea (x+w/2) y valeur
		|Noeud(valeur,l) -> 
			let longl=List.length l in
			let new_w=w/longl+1 in
				begin
				traceb (x+w/2) y valeur;
				for t=0 to (longl-1) do
					moveto (x+w/2) (y-20);
					lineto (x+new_w/2+t*new_w) (y-pasy)
				done;
				if longl=0 
				then failwith "Erreur : arbre malform"
				else traceliste x (y-pasy) (new_w) l
				end
in	rtrace arbre 0 (size_y()) (size_x())
;;

let traceint x y n =
	let tmpStr = string_of_int n
in	let (dimx,dimy)=text_size tmpStr
in	begin
	moveto (x-dimx/2) y;
	draw_string tmpStr
	end
;;

let test=Noeud (5,
		[Noeud(1,[Feuille 3;Noeud(15,[Feuille 18;Feuille 6])]);
		Feuille 6;Feuille 12]);;
open_graph ""; trace test traceint traceint 30;;


