(****** TIPE d'Informatique (2me anne) ******)
(* modifi le 09/11/97 *)



(** Transformation Arbre ---> Dessin **)
directory "";; (* A modifier selon le systme *)
open List;;
#load "graphics.cmo";;
open Graphics;;
#load "utilit.cmo";;
open Utilit;;

(* Un petit test qui marche *)
let test=Noeud (5,
		[Noeud(1,[Feuille 3;Noeud(15,[Feuille 18;Feuille 6])]);
		Feuille 6;Feuille 12]);;
open_graph "";;
dessine test afficheint afficheint black;;

(** Transformation Dessin ---> Arbre **)
(* Attention : _ CAML refuse de grer les fonctions "clavier" si on n'a pas fait un open_graph juste avant !!!
		   _ Les coordonnes (x,y) sont celles du coin SW de la fentre o est affich le sous-arbre (w : largeur)
		   _ Le type d'arbre choisi oblige pour chaque fonction  imbriquer deux fonctions rcursives *) 

(* Remplace par new_valeur la valeur repre par parcours dans l'arbre *) 
let rec remplace_dans_listearbre new_valeur k parcours = function
	|[] -> [Feuille new_valeur]
	|t::q when k>0 -> 
		if k=1
		then (remplace_dans_arbre new_valeur parcours t)::q
		else t::(remplace_dans_listearbre new_valeur (k-1) parcours q)
	|_ -> raise (Erreur "Argument non valide dans remplace_dans_listearbre")
and remplace_dans_arbre new_valeur parcours = function
	|Nil		-> Feuille new_valeur (* ou Nil : Voir si a marche *)
	|Feuille f  -> Feuille new_valeur
	|Noeud(x,l) -> match parcours with
				|[] -> Noeud(new_valeur,l)
				|(t,_)::q -> Noeud(x,remplace_dans_listearbre new_valeur t q l)
;;
(* open_graph "";;
dessine (remplace_dans_arbre 150 [1,3;2,2] test1) afficheint afficheint black;; *)

(* Ajoute une branche  l'endroit repr par parcours dans l'arbre *) 
let rec insere_dans_arbre branche parcours = function
	|Nil		-> branche
	|Feuille f  -> Noeud(f,[branche])
	|Noeud(x,l) -> match parcours with
				|[] -> Noeud(x,branche::l)
				|(t,_)::q -> Noeud(x, insere_dans_listearbre branche t q l)
and insere_dans_listearbre branche k parcours = function
	|[] -> [branche]
	|t::q when (k>0 && parcours=[])-> 
		if k=1
		then t::branche::q
		else t::(insere_dans_listearbre branche (k-1) parcours q)
	|t::q when k>0 -> 
		if k=1
		then (insere_dans_arbre branche parcours t)::q
		else t::(insere_dans_listearbre branche (k-1) parcours q)
	|_ -> raise (Erreur "Argument non valide dans remplace_dans_listearbre")
;;
(* open_graph "";;
dessine (insere_dans_arbre (Feuille 150) [1,3;2,2] test1) afficheint afficheint black;; *)

(* Supprime la branche  l'endroit repr par parcours dans l'arbre *) 
let rec suppr_dans_arbre parcours = function
	|Nil -> Nil
	|Feuille f -> Nil
	|Noeud(x,l) -> match parcours with
				|[] -> Nil
				|(t,_)::q -> Noeud(x, suppr_dans_listearbre t q l)
and suppr_dans_listearbre k parcours = function
	|[] -> []
	|t::q when k>0 -> 
		if k=1
		then (suppr_dans_arbre parcours t)::q
		else t::(suppr_dans_listearbre (k-1) parcours q)
	|_ -> raise (Erreur "Argument non valide dans suppr_dans_listearbre")
;;

(* open_graph "";;
dessine (suppr_dans_arbre [1,3;2,2] test1) afficheint afficheint black;; *)

(* Nettoie l'arbre des fils "Nil" et transforme les "Noeud(x,[])" en "Feuille x" *)
let rec nettoie_arbre = function
	|Noeud(x,l) -> if (l=[] or l=[Nil]) then (Feuille x) else Noeud(x,nettoie_listearbre l)
	|_ as arbre -> arbre
and nettoie_listearbre = function
	|[] 	-> []
	|t::q -> if t=Nil then nettoie_listearbre q else (nettoie_arbre t)::(nettoie_listearbre q)
;;

(* open_graph "";;
dessine (nettoie_arbre (suppr_dans_arbre [1,3;2,2] test1)) afficheint afficheint black;; *)

(* Calcul des coordonnes d'une valeur de l'arbre repre par parcours *) 
let calcul_param arbre parcours =
	let rec rcalcul (x,y,w) arbre = function
		|[] -> ((x,y,w),arbre)
		|(pos,max)::q -> let new_w=w/max in 
					match arbre with 
						|Noeud(_,l) -> rcalcul (x+(pos-1)*new_w, y-pasy, new_w) (kime pos l) q
						|_ -> raise (Erreur "Argument non valide dans calcul_param")
in	rcalcul (0,size_y(),size_x()) arbre parcours
;;
(* calcul_param test1 [1,3;2,2];; *)
 
(* Les arbres seront ici des arbres de string : Faire la conversion aprs.
   Pour pouvoir se dplacer, on enregistre dans parcours les dplacements 
dj effectus dans une liste sous forme de la position dans la liste des 
fils d'un Noeud. On enregistre aussi la longueur de la liste des fils pour
pouvoir se dplacer  l'intrieur sans erreur. Attention, quand on repart 
de la racine de l'arbre (pour calculer les coordonnes du point courant par 
exemple), il faut inverser le parcours, d'o les rev un peu partout. L'appui 
sur une touche modifie le parcours courant et le nouveau parcours est stock 
dans la rfrence new_parc. La rfrence arbre_copie sert au Copier/Coller.
	- Echap : sortie de la fonction
	- "8" : remonte dans l'arbre
	- "2" : descend dans l'arbre. Si Nil ou Feuille, cration d'une Feuille ou 
transformation de la Feuille en Noeud
	- "6" : va  droite et boucle sur la liste des fils
	- "4" : va  gauche et boucle sur la liste des fils
	- Entree : modifie la valeur du point courant
	- "+" : rajoute une Feuille  droite du point courant
	- "-" : supprime le point courant et va  droite ou en haut
	- "C" ou "c" : copie la branche o le curseur est plac
	- "X" ou "x" : coupe la branche o le curseur est plac
	- "V" ou "v" : colle la branche  droite de l'endroit o le curseur est plac
	- "R" ou "r" : redessine l'arbre *)
let fait_arbre arbre=
	let arbre_temp = ref arbre and new_parc=ref []
	and k=ref 0  and arbre_copie= ref Nil

in	open_graph "";
	while not(!k=27) do
		let ((x,y,w),current_arbre)=calcul_param !arbre_temp (rev !new_parc) and pos_et_max= !new_parc

in		begin
		dessine !arbre_temp affichestr affichestr black;
		dess_curs (x+w/2) y;
		
		while not(key_pressed()) do done;
	
		eff_curs (x+w/2) y;

		k:=Char.code (read_key());
		begin
		match !k with
(*8*)			|56 -> if pos_et_max=[] then new_parc:=[] else new_parc:=tl pos_et_max;

(*2*)			|50 -> (match current_arbre with
					|Nil -> 
						begin
						arbre_temp:=Feuille (saisie_ext ());
						new_parc:=[]
						end;
					|Feuille f -> let new_valeur=saisie_ext() in
						begin
						(*dessine !arbre_temp affichestr affichestr background;*)
						new_parc:=(1,1)::pos_et_max;
						arbre_temp:=insere_dans_arbre (Feuille new_valeur) (rev !new_parc) !arbre_temp
						end
					|Noeud(x,l) -> let longl=length l in new_parc:=((longl-1)/2+1,longl)::pos_et_max)

(*6*)			|54 -> if pos_et_max=[] then new_parc:=[]
				 else let (curr,max)=hd pos_et_max in
					new_parc:=(curr mod max +1,max)::(tl pos_et_max);

(*4*)			|52 -> if pos_et_max=[] then new_parc:=[]
				 else let (curr,max)=hd pos_et_max in
					new_parc:=((curr+max-2) mod max +1,max)::(tl pos_et_max);

(*Entree*)	|13 -> let new_valeur=saisie_int (x+w/2) y (racine current_arbre) in
				 begin
				 dessine !arbre_temp affichestr affichestr background;
				 arbre_temp:=remplace_dans_arbre new_valeur (rev pos_et_max) !arbre_temp;
				 new_parc:=pos_et_max
				 end;

(*+*)			|43 -> if pos_et_max=[] then new_parc:=pos_et_max
				 else let new_valeur=saisie_ext() and (pos,max)=hd pos_et_max in
					begin
					dessine !arbre_temp affichestr affichestr background;
					arbre_temp:=insere_dans_arbre (Feuille new_valeur) (rev pos_et_max) !arbre_temp;
					new_parc:=(pos+1,max+1)::(tl pos_et_max);
					end;

(*-*)			|45 -> if pos_et_max=[] then new_parc:=pos_et_max
				 else let (pos,max)=hd pos_et_max in
					begin
					dessine !arbre_temp affichestr affichestr background;
					arbre_temp:=suppr_dans_arbre (rev pos_et_max) !arbre_temp;
					if max=1 then new_parc:=tl pos_et_max
					else if pos=1 then new_parc:=(1,max-1)::(tl pos_et_max)
							  else new_parc:=(pos-1,max-1)::(tl pos_et_max)
					end;

(*C*)			|67|99 -> arbre_copie:=current_arbre; new_parc:=pos_et_max;

(*X*)			|88|120 -> if pos_et_max=[] then new_parc:=pos_et_max
				 	else let (pos,max)=hd pos_et_max in
						begin
						arbre_copie:=current_arbre;
						dessine !arbre_temp affichestr affichestr background;
						arbre_temp:=suppr_dans_arbre (rev pos_et_max) !arbre_temp;
						if max=1 then new_parc:=tl pos_et_max
						else if pos=1 then new_parc:=(1,max-1)::(tl pos_et_max)
								  else new_parc:=(pos-1,max-1)::(tl pos_et_max)
						end;

(*V*)			|86|118 -> if pos_et_max=[] then new_parc:=pos_et_max
					 else let (pos,max)=hd pos_et_max in
						begin
						dessine !arbre_temp affichestr affichestr background;
						arbre_temp:=insere_dans_arbre !arbre_copie (rev pos_et_max) !arbre_temp;
						new_parc:=(pos+1,max+1)::(tl pos_et_max);
						end;

(*R*)			|82|114 -> clear_graph(); new_parc:=pos_et_max;

				|_ -> new_parc:=pos_et_max;

		end;

		arbre_temp:=nettoie_arbre !arbre_temp;
		(* dessine !arbre_temp affichestr affichestr black *)
		end
	done;
	!arbre_temp
;;

(* Pour crer un arbre  partir de rien (enfin de Nil) et pour modifier un arbre *) 
let cree_arbre () = fait_arbre Nil;;
let modif_arbre arbre = fait_arbre arbre;;

let test2=Noeud ("5",[Noeud("1",[Feuille "3";Noeud("15",[Feuille "18";Feuille "6"])]);Feuille "6";Feuille "12"]);;
modif_arbre test2;;

(*
open_graph "";;
let test ()=let k=ref ' ' in
while (Char.code !k)<>27 do
	while not(key_pressed()) do done;
	k:=read_key();
	print_string (Char.escaped !k); print_newline();
done;;
test();;
*)


